unit exmain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DBGrids, Db, bindata, ExtCtrls, DBCtrls, bindatatr;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    SafeBinaryDataSet1: TSafeBinaryDataSet;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
VAR
  tds : tBinaryDataSet;
begin
  DataSource1.Enabled := False;
  if SafeBinaryDataSet1.Active then
    SafeBinaryDataSet1.Close;
  SafeBinaryDataSet1.TableName := 'TABLE1.DAT';
  if FileExists('TABLE1.DAT') then
    SafeBinaryDataSet1.Open
  ELSE BEGIN
    tds := tBinaryDataSet.Create(nil);
    tds.TableName := 'TABLE1.DAT';
    tds.FieldDefs.Clear;
    tds.FieldDefs.Add('NAME',ftString,40,False);
    tds.FieldDefs.Add('AGE',ftInteger,0,False);
    tds.CreateTable;
    tds.Free;
    SafeBinaryDataSet1.Active := False;
    SafeBinaryDataSet1.Open;
  END;
  DataSource1.Enabled := True;
{  DataSource1.Enabled := False;
  if BinaryDataSet1.Active then
    BinaryDataSet1.Close;
  BinaryDataSet1.TableName := 'TABLE2.DAT';
  if FileExists('TABLE2.DAT') then
    BinaryDataSet1.Open
  else BEGIN
    tds := tBinaryDataSet.Create(nil);
    tds.TableName := 'TABLE2.DAT';
    tds.FieldDefs.Clear;
    tds.FieldDefs.Add('PROJECT',ftString,40,False);
    tds.FieldDefs.Add('AUTHOR',ftString,40,False);
    tds.CreateTable;
    tds.Free;
    BinaryDataSet1.Active := False;
    BinaryDataSet1.Open;
  END;
  DataSource1.Enabled := True; }
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SafeBinaryDataSet1.Commit;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SafeBinaryDataSet1.Rollback;
end;

end.
